=== debian/changelog ===
gmqcc (0.3.5+git20230505-2) unstable; urgency=medium

  * Fix build on big-endian archs

 -- Sébastien Noel <sebastien@twolife.be>  Sat, 08 Nov 2025 23:46:23 +0100

gmqcc (0.3.5+git20230505-1) unstable; urgency=low

  [ Anton Balashov ]
  * Initial release (Closes: #712125)
  * gmqcc_man_hyphen.patch added

  [ David Bate ]
  * Perform copyright review and elaborate upon debian/copyright

  [ Sébastien Noel ]
  * Update packaging for an recent git snapshot of gmqcc.
    Current stable version doesn't compile with recent GCC.

 -- Sébastien Noel <sebastien@twolife.be>  Fri, 04 Apr 2025 13:29:30 +0200
