=== debian/control ===
Source: gmqcc
Section: devel
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Sébastien Noel <sebastien@twolife.be>
Build-Depends: debhelper-compat (= 13)
Standards-Version: 4.7.2
Homepage: http://graphitemaster.github.io/gmqcc/
Vcs-Git: https://salsa.debian.org/games-team/gmqcc.git
Vcs-Browser: https://salsa.debian.org/games-team/gmqcc

Package: gmqcc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Improved Quake C compiler
 GMQCC compiles QuakeC source code to binary, platform-independent code
 that Quake based engines can interpret. QuakeC is the language that
 Quake game logic is developed in and is used for developing
 modifications.
 .
 GMQCC is a modern QuakeC compiler, capable of generating correct,
 optimal code and adds new features and tools not present in its
 predecessors.  It is backwards compatible with previous compilers such
 as FTEQCC.
