=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CXXFLAGS+=$(CPPFLAGS)

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- CXXFLAGS="${CXXFLAGS}" LDFLAGS="${LDFLAGS}"
