=== debian/watch ===
Version: 5
#Template: Github
#Owner: graphitemaster
#Project: gmqcc
Mode: git
Source: https://github.com/graphitemaster/gmqcc.git
Matching-Pattern: HEAD
Git-Pretty: 0.3.5+git%cd
