## gmqcc 0.3.5+git20251116

=== Makefile ===
--- 
+++ 
@@ -49,6 +49,8 @@
 
 # Collect all the source files for QCVM.
 QSRCS := exec.cpp
+QSRCS += conout.cpp
+QSRCS += opts.cpp
 QSRCS += stat.cpp
 QSRCS += util.cpp
