=== debian/changelog ===
gmqcc (0.3.5+git20251116-1) unstable; urgency=medium

  * New upstream snapshot.
    + drop patches merged upstream

 -- Sébastien Noel <sebastien@twolife.be>  Wed, 19 Nov 2025 09:10:01 +0100
